// 002 u_c_html_generator
// 06 nov 2006

// -- (C) Felix John COLIBRI 2004
// -- documentation: http://www.felix-colibri.com

(*$r+*)

unit u_c_html_generator;
  interface
    uses u_c_basic_object
        , u_c_generator_2;

    type c_html_generator= class(c_generator)
                             Constructor create_html_generator(p_name: String);

                               function f_attributes(p_attributes: String): String;
                             procedure add_table_start(p_attributes: String);
                             procedure add_row_start(p_attributes: String);
                             procedure add_cell_start(p_attributes: String);

                             procedure add_cell_end;
                             procedure add_row_end;
                             procedure add_table_end;

                             procedure add_bullet_list_start;
                             procedure add_bullet_list_end;

                             Destructor Destroy; Override;
                           end; // c_html_generator

  implementation
    uses SysUtils, u_c_display;

    // -- c_html_generator

    Constructor c_html_generator.create_html_generator(p_name: String);
      begin
        Inherited create_generator(p_name);
      end; // create_html_generator

    function c_html_generator.f_attributes(p_attributes: String): String;
      begin
        Result:= Trim(p_attributes);
        if Result<> ''
          then Result:= ' '+ Result;
      end; // f_attributes

    procedure c_html_generator.add_table_start(p_attributes: String);
      begin
        add_line_indent('<TABLE'+ f_attributes(p_attributes)+ '>');
      end; // add_table_start

    procedure c_html_generator.add_row_start(p_attributes: String);
      begin
          // add_line_indent(                '<TR height='+ IntToStr(p_height)+ '>');
        add_line_indent('<TR '+ f_attributes(p_attributes)+ '>');
      end; // add_row_start

    procedure c_html_generator.add_cell_start(p_attributes: String);
      begin
        add_line_indent('<TD '+ f_attributes(p_attributes)+ '>');
      end; // add_cell_start

    procedure c_html_generator.add_cell_end;
      begin
        unindent_add_line('</TD>');
      end; // add_cell_end

    procedure c_html_generator.add_row_end;
      begin
        unindent_add_line('</TR>');
      end; // add_row_end

    procedure c_html_generator.add_table_end;
      begin
        unindent_add_line('</TABLE>');
      end; // addtable_end

    procedure c_html_generator.add_bullet_list_start;
      begin
        add_line_indent('<UL>');
      end; // add_bullet_list_start

    procedure c_html_generator.add_bullet_list_end;
      begin
        unindent_add_line('</UL>');
      end; // add_bullet_list_end

    Destructor c_html_generator.Destroy;
      begin
        Inherited;
      end; // Destroy

    begin // u_c_html_generator
    end. // u_c_html_generator


