// 003 u_rss_reader
// 06 nov 2006

// -- (C) Felix John COLIBRI 2004
// -- documentation: http://www.felix-colibri.com

(*$r+*)

unit u_rss_reader;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, FileCtrl, ExtCtrls, ComCtrls, OleCtrls, SHDocVw
  , u_c_blog_reader
  ;

type
  TForm1 = class(TForm)
    Panel1: TPanel;
    Panel3: TPanel;
    PageControl1: TPageControl;
    display_: TTabSheet;
    rss_: TTabSheet;
    Memo1: TMemo;
    rss_memo_: TMemo;
    Panel2: TPanel;
    exit_: TButton;
    clear_: TButton;
    PageControl2: TPageControl;
    url_dir_: TTabSheet;
    url_directory_listbox_: TDirectoryListBox;
    url_file_listbox_: TFileListBox;
    rss_down_: TTabSheet;
    Panel7: TPanel;
    analyze_: TButton;
    stats_panel_: TLabel;
    rss_tree_: TTabSheet;
    download_panel_: TPanel;
    load_url_: TButton;
    url_listbox_: TListBox;
    Splitter1: TSplitter;
    Panel8: TPanel;
    Label2: TLabel;
    rss_url_edit_: TEdit;
    rss_content_: TTabSheet;
    rss_tree_memo_: TMemo;
    rss_treeview_: TTreeView;
    Splitter2: TSplitter;
    blog_item_memo_: TMemo;
    blog_item_url_memo_: TMemo;
    do_download_: TCheckBox;
    procedure FormCreate(Sender: TObject);
    procedure url_file_listbox_Click(Sender: TObject);
    procedure exit_Click(Sender: TObject);
    procedure clear_Click(Sender: TObject);
    procedure url_directory_listbox_Change(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure analyze_Click(Sender: TObject);
    procedure url_listbox_Click(Sender: TObject);
    procedure load_url_Click(Sender: TObject);
    procedure rss_treeview_Change(Sender: TObject; Node: TTreeNode);
  private
    procedure handle_donwloaded_rss_feed(p_c_blog_reader: c_blog_reader);
  public
  end;

var
  Form1: TForm1;

implementation
  uses mshtml
      , u_types_constants, u_c_log, u_c_display
      , u_file, u_dir
      , u_c_ini_file
      , u_characters, u_strings

      , u_c_xml_scanner
      , u_c_xml_parser_2
      , u_c_xml_tree
      , u_c_html_generator
      , u_html

      , u_c_blog_item_list

      ;

    {$R *.DFM}

   
  
    const k_initial_directory= '..\_data\1_rss_url_list\';
          // -- for the start, this will be relative to the previous path
          k_initial_rss_path= '..\2_rss_files\';
            k_extension= '.*';
            k_file_name= 'pascal.pas';
            k_initial_url= 'http://www.felix-colibri.com/feed.rss';

          k_xxx_path_ini_key=   'ini_xxx_path';
          k_xxx_file_name_ini_key= 'ini_xxx_file_name';

          k_rss_url_ini_key= 'url_name';

          k_rss_path_ini_key=   'ini_rss_path';
          k_rss_file_name_ini_key= 'ini_rss_file_name';

    var g_path: String= k_initial_directory;
        g_file_name: String= k_file_name;

        g_rss_url: String= k_initial_url;

        g_rss_path: String= k_initial_rss_path;
        g_rss_file_name: String= k_file_name;

        g_c_ini_file: c_ini_file= Nil;

        g_file_count: Integer= 0;

    var // -- this is never nil, since created in OnCreate
        g_c_blog_reader: c_blog_reader= Nil;

    procedure display_stats;
      begin
        with g_c_blog_reader do
          Form1.stats_panel_.Caption:= Format('rss %5d, htlm %5d ', [m_rss_size div 1024, m_html_size div 1024]);
      end; // display_stats

    // -- events

    procedure TForm1.FormCreate(Sender: TObject);
      var l_rss_url_indexof: Integer;
          l_rss_url_to_file_name: String;
      begin
        initialize_display(Memo1.Lines);
        initialize_default_log;

        g_c_blog_reader:= c_blog_reader.create_blog_reader('blog_reader');

        g_c_ini_file:= c_ini_file.create_ini_file('');
        with g_c_ini_file do
        begin
          // -- whatever is in "fig_ini.txt"
          load_from_default_file;

          // -- initialize the variables with INI or, if none, with constants
          g_path:= f_initialize_parameter(k_xxx_path_ini_key, k_initial_directory);
          g_file_name:= f_initialize_parameter(k_xxx_file_name_ini_key, k_file_name);

          g_rss_url:= f_initialize_parameter(k_rss_url_ini_key, k_initial_url);

          g_rss_path:= f_initialize_parameter(k_rss_path_ini_key, k_initial_rss_path);
          g_rss_file_name:= f_initialize_parameter(k_rss_file_name_ini_key, k_file_name);

          // -- keep in step
          l_rss_url_to_file_name:= g_c_blog_reader.f_rss_url_to_file_name(g_rss_url);
          if l_rss_url_to_file_name<> g_rss_file_name
            then g_rss_file_name:= l_rss_url_to_file_name;
        end; // with g_c_ini_file

        set_directory_listbox_directory(url_directory_listbox_, g_path);
        Caption:= g_path+ g_file_name;
        // -- if relative and initialise, synchronize
        if g_rss_path= k_initial_rss_path
          then g_rss_path:= g_path+ k_initial_rss_path;

        display('url_list');
        display('  '+ g_path+ g_file_name);
        display('rss_url');
        display('  '+ g_rss_url);
        display('rss_file');
        display('  '+ g_rss_path+ g_rss_file_name);

        with url_file_listbox_ do
        begin
          ItemIndex:= Items.IndexOf(g_file_name);
          if ItemIndex>= 0
            then begin
                // -- load the url list
                url_file_listbox_Click(Nil);

                // -- if any name matches the ini url, hilite it
                l_rss_url_indexof:= url_listbox_.Items.IndexOf(g_rss_url);
                display('index_of >'+ g_rss_url+ '< '+ IntToStr(l_rss_url_indexof));
                if l_rss_url_indexof>= 0
                  then begin
                      url_listbox_.ItemIndex:= l_rss_url_indexof;
                      rss_url_edit_.Text:= g_rss_url;
                    end;
              end;
        end; // with url_file_listbox_

        with g_c_blog_reader do
        begin
          m_rss_path:= g_rss_path;
          m_rss_file_name:= g_rss_file_name;
        end; // with g_c_blog_reader
      end; // FormCreate

    procedure TForm1.exit_Click(Sender: TObject);
      begin
        Close;
      end; // exit_Click

    procedure TForm1.clear_Click(Sender: TObject);
      begin
        clear_display;
      end; // clear_Click

    procedure TForm1.url_directory_listbox_Change(Sender: TObject);
      begin
        with url_directory_listbox_ do
          g_path:= GetItemPath(ItemIndex)+ '\';
        g_c_ini_file.set_parameter(k_xxx_path_ini_key, g_path);
        Caption:= g_path+ g_file_name;
      end; // DirectoryListBox1Change

    procedure TForm1.url_file_listbox_Click(Sender: TObject);
        // -- the file clicked in the bottom list_box
      begin
        with url_file_listbox_ do
          g_file_name:= Items[ItemIndex];
        g_c_ini_file.set_parameter(k_xxx_file_name_ini_key, g_file_name);
        Caption:= g_path+ g_file_name;

        // -- load all the rss urls
        url_listbox_.Items.LoadFromFile(g_path+ g_file_name);
      end; // FileListBox1Click

    procedure TForm1.FormClose(Sender: TObject; var Action: TCloseAction);
      begin
        g_c_ini_file.save_to_default_file;
      end; // FormClose

    procedure TForm1.load_url_Click(Sender: TObject);
        // -- load the list of rss urls
      begin
        url_file_listbox_Click(Nil);
      end; // load__Click

    // -- download the selected rss

    var g_rss_save_file_name: String= '';

    procedure TForm1.url_listbox_Click(Sender: TObject);
      begin
        display('> url_listbox_Click');
        PageControl1.ActivePage:= display_;

        with url_listbox_ do
          g_rss_url:= Items[ItemIndex];

        g_c_ini_file.set_parameter(k_rss_url_ini_key, g_rss_url);

        display(g_rss_url);
        rss_url_edit_.Text:= g_rss_url;

        if do_download_.Checked
          then begin
              download_panel_.Color:= clRed;
              g_c_blog_reader.download_rss(g_rss_url, handle_donwloaded_rss_feed);
            end
          else begin
              g_rss_file_name:= g_c_blog_reader.f_rss_url_to_file_name(g_rss_url);
              if FileExists(g_rss_path+ g_rss_file_name)
                then rss_memo_.Lines.LoadFromFile(g_rss_path+ g_rss_file_name)
                else display_bug_stop('no_file '+ g_rss_path+ g_rss_file_name);
            end;

        display('< url_listbox_Click');
      end; // url_listbox_Click

    procedure TForm1.handle_donwloaded_rss_feed(p_c_blog_reader: c_blog_reader);
        // -- here has received all the rss file
        // --  => analyze it and start IE
      begin
        display('> handle_donwloaded_rss_feed');
        with g_c_blog_reader do
        begin
          g_rss_file_name:= m_rss_file_name;
          display('save '+ g_rss_path+ g_rss_file_name);
          m_c_rss_content.SaveToFile(g_rss_path+ g_rss_file_name);
          rss_memo_.Lines.LoadFromFile(g_rss_path+ g_rss_file_name);
        end; // with g_c_blog_reader

        download_panel_.Color:= clLime;
        display_stats;
        display('< handle_donwloaded_rss_feed');
      end ; // handle_donwloaded_rss_feed

    procedure TForm1.analyze_Click(Sender: TObject);
      begin
        display('> analyze_Click '+ g_rss_path+ g_rss_file_name);
        PageControl1.ActivePage:= display_;

        with g_c_blog_reader do
        begin
          load_rss_file(g_rss_path, g_rss_file_name);
          analyze_rss;

          with m_c_xml_text do
          begin
            // -- the structure (not the content)
            display_xml_tags_only;

            // -- the full content, re-indented
            initialize_display(rss_tree_memo_.Lines);
            display_xml_text;
            initialize_display(Memo1.Lines);
          end; // with m_c_xml_text

          display('> blog_item_list');
          m_c_blog_item_list.display_blog_item_list;
          display('< blog_item_list');

          rss_treeview_.Items.Clear;
          m_c_blog_item_list.build_treeview(rss_treeview_);
        end; // with g_c_blog_reader

        PageControl1.ActivePage:= rss_;
        display('< analyze_Click ');
      end; // analyze_Click

    procedure TForm1.rss_treeview_Change(Sender: TObject; Node: TTreeNode);
      var l_c_blog_item: c_blog_item;
      begin
        with Node do
        begin
          display(Text);
          l_c_blog_item:= c_blog_item(Data);
          if l_c_blog_item<> Nil
            then
              with l_c_blog_item do
              begin
                blog_item_url_memo_.Text:= m_url;
                blog_item_memo_.Text:= m_description;
              end;
        end; // with Node
      end; // rss_treeview_Change

    end.


